<?php
	if (true) error_reporting (E_ALL|E_STRICT); else error_reporting (0);
	if (!version_compare(PHP_VERSION, '5.2.0', '>=')) die ("You get this error message because your webserver supports PHP 5.1 or lower. But ezStats requires PHP version 5.2 or higher. Please contact your webhost and let update your webpackage.");
	function get_template($template) { return str_replace("\"", "\\\"", file_get_contents("templates/".$template.".html")); }
	
	
	require '../scripts/vendor/pqlite.php';
	require '../classes/settings.php';
	require '../classes/mysql.php';
	require '../classes/security.php';
	require '../classes/functions.php';
	
	$config = array();
	$config['version'] = "0.32";
	$config['gamename'] = "World of Tanks";
	$config['gameabbr'] = "wot";
	$config['prefix'] = "ez3wot__";
	$config['sqlfile'] = "../tmp/sql.php";
	$config['defaults'] = "../tmp/defaults.js";
	$config['chmod_test'] = Array("Folder 'tmp'" => "../tmp");
	$config['server_test'] = Array("json" => "JSON", "curl" => "cURL", "gd" => "GD library");
	$config['disable_test'] = Array("curl_init", "curl_setopt", "curl_exec", "curl_getinfo", "curl_close", "json_decode", "file_get_contents");
	
	
	/* 
		STARTING PAGE
	*/
	if (!isset($_POST['step'])) {
		// Start of the installation
		eval ("\$welcome = \"".get_template("welcome")."\";");
		
		// Load of the default template
		eval ("\$index = \"".get_template("_index")."\";");
		$html = new PQLite($index);
		
		// Page output
		$html->find('#content')->setInnerHTML($welcome);
		$html->find('#button a')->setAttr("href", "chmod")->setInnerHTML("Next");
		die($html->getHTML());
	} 
	
	
	/*
		SERVER TEST (CHMOD)
		CREATE DEFAULT SQL-FILE
		GENERATE FORM (SQL-DATA)
	*/
	if ($_POST['step'] == "chmod") {
		/* SERVER TEST (CHMOD) */
		if (true) {
			$check = true;
			$list = new PQLite('<ul></ul>');
			
			// Check of files and folders from $config['chmod_test'], if they have CHMOD 777
			foreach ($config['chmod_test'] as $key => $value) {
				if (is_writable($value)) {
					$list->find('ul')->appendHTML('<li>- '.$key.'&nbsp;&nbsp;&nbsp;... OK!</li>');
				} else {
					$list->find('ul')->appendHTML('<li>- '.$key.'&nbsp;&nbsp;&nbsp;... FAILED!</li>');
					$check = false;
				}
			}
			
			// Test of file "sql.php" if it exists
			if (file_exists($config['sqlfile'])) {
				if (is_writable($config['sqlfile'])) {
					$list->find('ul')->appendHTML('<li>- File \''.$config['sqlfile'].'\'&nbsp;&nbsp;&nbsp;... OK!</li>');
				} else {
					$list->find('ul')->appendHTML('<li>- File \''.$config['sqlfile'].'\'&nbsp;&nbsp;&nbsp;... FAILED!</li>');
					$check = false;
				}
			}
			
			// CHMOD-Test is failed
			if (!$check) {
				eval ("\$html = \"".get_template("chmod")."\";");
				$html = new PQLite($html);
				$html->find("#list")->appendHTML($list->getHTML());
				
				$result = Array(
					"html" => $html->getHTML(),
					"step" => "chmod",
					"button" => "retry",
					"error" => ""
				);
				die (json_encode($result));
			}
		}
		
		
		/* CREATE DEFAULT SQL-FILE */
		if (true) {
			// SQL-File doesn't exists; it is filled with default values
			if (!file_exists($config['sqlfile'])) {
				$handle = fopen($config['sqlfile'], "w") 
					or die (json_encode(Array(
						"html" => "",
						"step" => "chmod",
						"button" => "retry",
						"error" => "Error: Failure during creation of file sql.php"
					)));
				
				$mysqli = version_compare(PHP_VERSION, '5.5.0', '>=') ? 1 : 0;
				
				fwrite($handle, '<?php define (\'SQL\', \' {"debug": "0", "mysqli": "'.$mysqli.'", "sqldb": "ezstats3", "sqlhost": "localhost", "sqluser": "root", "sqlpwd": "", "prefix": "'.$config['prefix'].'"} \'); ?>');
				fclose($handle);
			}
		}
		
		
		/* GENERATE FORM (SQL-DATA) */
		if (true) {
			require ($config['sqlfile']);
			$sqldata = json_decode(SQL);
			
			eval ("\$html = \"".get_template("sqldata")."\";");
			$html = new PQLite($html);
			
			/* Workaround for older installation without MySQLi selection */
			if (isset($sqldata->mysqli)) {
				$mysqli = $sqldata->mysqli;
			} else {
				$mysqli = version_compare(PHP_VERSION, '5.5.0', '>=') ? 1 : 0;
			}
			$html->find('#mysqli_'.$mysqli)->setAttr('checked', 'checked');
			
			$result = Array(
				"html" => $html->getHTML(),
				"step" => "sqldata",
				"button" => "next",
				"error" => ""
			);
			die (json_encode($result));
		}
	}
	
	
	/*
		WRITE INTO SQL-FILE
		SERVER TEST (PHP-VERSION / PHP-FUNCTIONS)
	*/
	if ($_POST['step'] == "sqldata") {
		/* WRITE INTO SQL-FILE */
		if (true) {
			// Save the SQL data into the file "sql.php", if input is given
			if (isset($_POST['input']['sqlhost'])) {
				// Check the connectivity to the database
				if ($_POST['input']['mysqli']) {
					$connect = @mysqli_connect($_POST['input']['sqlhost'], $_POST['input']['sqluser'], $_POST['input']['sqlpwd'], $_POST['input']['sqldb']);
					
					if (!$connect) {
						$successful = false;
					} else {
						$successful = true;
						mysqli_close($connect);
					}
				} else {
					$connect  = @mysql_connect($_POST['input']['sqlhost'], $_POST['input']['sqluser'], $_POST['input']['sqlpwd']);
					$select   = @mysql_select_db($_POST['input']['sqldb'], $connect);
					
					if (!$connect OR !$select) {
						$successful = false;
					} else {
						$successful = true;
						mysql_close($connect);
					}
				}
				
				// If the check fails, go back to SQL form with error message
				if (!$successful) {
					$result = Array(
						"html" => "",
						"step" => "sqldata",
						"button" => "retry",
						"error" => "Could not connect to database. Please check your values."
					);
					die (json_encode($result));
				}
				
				
				// If the check succeeds, save SQL data
				$handle = fopen($config['sqlfile'], "w") 
					or die (json_encode(Array("html" => "Error: Failure during creation of file sql.php")));
				
				fwrite($handle, '<?php define (\'SQL\', \' {"debug": "0", "mysqli": "'.$_POST['input']['mysqli'].'", "sqldb": "'.$_POST['input']['sqldb'].'", "sqlhost": "'.$_POST['input']['sqlhost'].'", "sqluser": "'.$_POST['input']['sqluser'].'", "sqlpwd": "'.$_POST['input']['sqlpwd'].'", "prefix": "'.$_POST['input']['prefix'].'"} \'); ?>');
				fclose($handle);
			}
		}
		
		
		/* SERVER TEST (PHP-VERSION / PHP-FUNCTIONS) */
		if (true) {
			// Check the server, if it supports neccessary PHP functions
			$check = true; $test="";
			$extensions = get_loaded_extensions();
			$list = new PQLite('<ul></ul>');
			
			if (!version_compare(PHP_VERSION, '5.2.0', '>=')) $check = false;
			$list->find('ul')->appendHTML('<li>- Needed PHP-Version: 5.2.0 - Your PHP-Version: '.PHP_VERSION.'</li>');
			
			foreach ($config['server_test'] as $key => $value) {
				if (in_array($key, $extensions)) {
					$list->find('ul')->appendHTML('<li>- Extension '.$value.'&nbsp;&nbsp;&nbsp;... INSTALLED!</li>');
				} else {
					$list->find('ul')->appendHTML('<li>- Extension '.$value.'&nbsp;&nbsp;&nbsp;... NOT INSTALLED!</li>');
					$check = false;
				}
			}
			
			foreach ($config['disable_test'] as $function) {
				if (function_exists($function)) {
					$list->find('ul')->appendHTML('<li>- Function '.$function.'&nbsp;&nbsp;&nbsp;... ENABLED!</li>');
				} else {
					$list->find('ul')->appendHTML('<li>- Function '.$function.'&nbsp;&nbsp;&nbsp;... DISABLED!</li>');
					$check = false;
				}
			}
			
			
			// If server check fails, show error message
			if (!$check) {
				$error = $list->getHTML();
				eval ("\$html = \"".get_template("server")."\";");
				
				$result = Array(
					"html" => $html,
					"step" => "sqldata",
					"button" => "retry",
					"error" => ""
				);
				die (json_encode($result));
			}
			
			
			// Server check succeeds. Go ahead with database installations
			eval ("\$html = \"".get_template("ready")."\";");
			
			$result = Array(
				"html" => $html,
				"step" => "tables",
				"button" => "... run the install",
				"error" => ""
			);
			die (json_encode($result));
		}
	}
	
	
	/*
		CREATE DATABASE TABLES
		WRITE DEFAULT VALUES INTO DATABASE
		GENERATE STATS KEY / SEND TELEMETRY DATA
		GENERATE FORM (ADMIN ACCOUNT)
	*/
	if ($_POST['step'] == "tables") {
		require $config['sqlfile'];
		function get_query($file, $prefix) { return str_replace("#PREFIX#", $prefix, file_get_contents("queries/".$file.".sql")); }
		
		$sql = new MySQL();
		$sql->debug = true;
		$secure = new Security();
		
		
		/* CREATE DATABASE TABLES */
		if (true) {
			$sql->query(get_query("localization_01", $sql->prefix));
			$sql->query(get_query("localization_02", $sql->prefix));
			$sql->query(get_query("localization_03", $sql->prefix));
			$sql->query(get_query("localization_04", $sql->prefix));
			$sql->query(get_query("localization_05", $sql->prefix));
			$sql->query(get_query("overview", $sql->prefix));
			$sql->query(get_query("platoons", $sql->prefix));
			$sql->query(get_query("player", $sql->prefix));
			$sql->query(get_query("plugins_01", $sql->prefix));
			$sql->query(get_query("plugins_02", $sql->prefix));
			$sql->query(get_query("plugins_03", $sql->prefix));
			$sql->query(get_query("settings", $sql->prefix));
			$sql->query(get_query("signatures", $sql->prefix));
			$sql->query(get_query("style", $sql->prefix));
			$sql->query(get_query("users", $sql->prefix));
			
			$sql->query(get_query("stats__basic", $sql->prefix));
			$sql->query(get_query("stats_achievements", $sql->prefix));
			$sql->query(get_query("stats_statistics", $sql->prefix));
			$sql->query(get_query("stats_ratings", $sql->prefix));
			$sql->query(get_query("stats_membership", $sql->prefix));
		}
		
		
		/* WRITE DEFAULT VALUES INTO DATABASE */
		if (true) {
			// Save the defaults
			if ($defaults = json_decode(@file_get_contents($config['defaults']))) {
				foreach ($defaults as $table => $presets) {
					foreach ($presets as $name => $value) {
						$sql->query('SELECT value FROM '.$sql->prefix . $table.' WHERE name = "'.$name.'"');
						if (!$sql->count()) $sql->query('INSERT INTO '.$sql->prefix . $table.' (name, value) VALUES ("'.$name.'", "'.$value.'")');
					}
				}
			} else {
				$result = json_encode(Array(
					"html" => "",
					"step" => "tables",
					"button" => "retry",
					"error" => "Error: Failure during loading of file defaults.js"
				));
				die ($result);
			}
			
			// Save the settings
			$sql->query('UPDATE '.$sql->prefix.'settings SET value = "'.$config['gamename'].'" WHERE name = "default_gamename"');
			$sql->query('UPDATE '.$sql->prefix.'settings SET value = "'.$config['gameabbr'].'" WHERE name = "default_gameabbr"');
			$sql->query('UPDATE '.$sql->prefix.'settings SET value = "'.$config['version'].'" WHERE name = "properties_version"');
		}
		
		
		/* GENERATE STATS KEY / SEND TELEMETRY DATA */
		if (true) {
			// Generate and save IDENT and KEY for official Stats Server
			if (function_exists('curl_init')) {
				// Fetch telemetric data
				$sql->query('SELECT value FROM '.$sql->prefix .'settings WHERE name = "functions_cms"');        $cms = $sql->fetchRow("value");
				$sql->query('SELECT value FROM '.$sql->prefix .'settings WHERE name = "functions_signatures"'); $sig = $sql->fetchRow("value");
				
				$data = Array(
					"test"      => "curl",
					"game"      => $config['gameabbr'],
					"version"   => $config['version'],
					"cms"       => $cms,
					"sig"       => $sig,
					"baseurl"   => $_SERVER['HTTP_HOST'],
					"scripturl" => $_SERVER['HTTP_HOST']."/".str_replace($_SERVER['DOCUMENT_ROOT'], "", $_SERVER['SCRIPT_FILENAME'])
				);
				
				// Call key server
				$ch = curl_init("http://curl.ezstats.org/");
				curl_setopt($ch, CURLOPT_POST, true); 
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
				curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
				$data = curl_exec($ch); curl_close($ch);
				$data = explode('||', $data);
				
				// Save generated stats key
				if (isset($data[0])) $sql->query('UPDATE '.$sql->prefix.'settings SET value = "'.$data[0].'" WHERE name = "properties_ident"');
				if (isset($data[1])) $sql->query('UPDATE '.$sql->prefix.'settings SET value = "'.$data[1].'" WHERE name = "properties_key"');
			} else die("Error: cURL-function required to proceed");
		}
		
		
		/* GENERATE FORM (ADMIN ACCOUNT) */
		if (true) {
			eval ("\$html = \"".get_template("admin")."\";");
			$html = new PQLite($html);
			
			$sql->query('SELECT * FROM '.$sql->prefix.'users WHERE id = 1');
			if ($sql->count()) {
				$row = $sql->fetchRow();
				$html->find('#name')->setAttr('value', $row['name']);
				$html->find('#password')->setAttr('value', $row['password']);
			}
			
			$result = Array(
				"html" => $html->getHTML(),
				"step" => "admin",
				"button" => "next",
				"error" => ""
			);
			die (json_encode($result));
		}
	}
	
	
	/*
		CREATE ADMIN ACCOUNT
		GENERATE FORM (SETTINGS)
	*/
	if ($_POST['step'] == "admin") {
		require $config['sqlfile'];
		$sql = new MySQL();
		$secure = new Security();
		$func = new Functions();
		
		
		/* CREATE ADMIN ACCOUNT */
		if (true) {
			// Speichern des Adminaccounts, wenn Formulardaten bergeben wurden
			if (isset($_POST['input']['name'])) {
				// Wurde fr Name ein Wert angegeben?
				if ($_POST['input']['name'] == "") {
					$result = Array(
						"html" => "",
						"step" => "admin",
						"button" => "retry",
						"error" => "Error: Please enter a username!"
					);
					die (json_encode($result));
				} 
				else {
					// Existiert User mit ID=1?
					$sql->query('SELECT * FROM '.$sql->prefix.'users WHERE id = 1');
					if ($sql->count()) {
						// Sind die Namen identisch?
						$user = $sql->fetchRow();
						if ($user['name'] == $_POST['input']['name']) {
							// Sind die Passwrter identisch?
							if ($user['password'] == $_POST['input']['password']) {
								// Nichts machen, weiter mit dem nchsten Schritt
							} else {
								// Passwort abspeichern mit md5()
								$sql->query('UPDATE '.$sql->prefix.'users SET password = "'.md5($_POST['input']['password']).'" WHERE id = 1');
							}
						} else {
							// Existiert der User mit dem Namen schon?
							$sql->query('SELECT id FROM '.$sql->prefix.'users WHERE name = "'.$_POST['input']['name'].'"');
							if ($sql->count()) {
								// Diesen User vorher lschen
								$user = $sql->fetchRow();
								$sql->query('DELETE FROM '.$sql->prefix.'users WHERE id = "'.$user['id'].'"');
							}
							
							// Den Datensatz ID=1 berschreiben
							$sql->query('
								UPDATE '.$sql->prefix.'users SET 
									name = "'.$_POST['input']['name'].'", 
									password = "'.md5($_POST['input']['password']).'"
								WHERE id = 1
							');
						}
					} else {
						// Den Account so abspeichern
						$sql->query('INSERT INTO '.$sql->prefix.'users (
							name, 
							password, 
							adminpower
						) VALUES (
							"'.$_POST['input']['name'].'", 
							"'.md5($_POST['input']['password']).'",
							1
						)');
					}
				}
			}
		}
		
		
		/* GENERATE FORM (SETTINGS) */
		if (true) {
			// Load the template
			eval ("\$html = \"".get_template("settings")."\";");
			$html = new PQLite($html);
			
			
			// Generate array with supported languages
			$languages = Array();
			$sql->query('SHOW COLUMNS FROM '.$sql->prefix.'localization');
			
			while ($row = $sql->fetchRow()) {
				if ($row['Field'] != "id" AND $row['Field'] != "category" AND $row['Field'] != "wildcard") 
				$languages[] = $row['Field'];
			}
			
			
			// Insert settings from the database into the form
			// Clanname
			$sql->query('SELECT value FROM '.$sql->prefix.'settings WHERE name = "settings_clanname"');
			$result = $sql->fetchRow();
			$html->find('#settings_clanname')->setAttr('value', $result['value']);
			
			// Clanpage
			$sql->query('SELECT value FROM '.$sql->prefix.'settings WHERE name = "settings_clanpage"');
			$result = $sql->fetchRow();
			$html->find('#settings_clanpage')->setAttr('value', $result['value']);
			
			// Plattform
			/*$sql->query('SELECT value FROM '.$sql->prefix.'settings WHERE name = "settings_platform"');
			$result = $sql->fetchRow();
			$html->find('#settings_platform_'.$result['value'])->setAttr('checked', 'checked');*/
			
			// Region
			$sql->query('SELECT value FROM '.$sql->prefix.'settings WHERE name = "settings_region"');
			$result = $sql->fetchRow();
			$html->find('#settings_region_'.$result['value'])->setAttr('checked', 'checked');
			
			// Language
			$sql->query('SELECT value FROM '.$sql->prefix.'settings WHERE name = "settings_language"');
			$result = $sql->fetchRow();
			$option = "";
			foreach ($languages as $lang) {
				if ($lang == $result['value'])
					 $option .= '<option selected="selected">'.$lang.'</option>';
				else $option .= '<option>'.$lang.'</option>';
			}
			$html->find('#settings_language')->setInnerHTML($option);
			
			// Timezone
			$sql->query('SELECT value FROM '.$sql->prefix.'settings WHERE name = "settings_timezone"');
			$result = $sql->fetchRow();
			$html->find('#settings_timezone')->setInnerHTML($func->select_timezone($result['value']));
		}
		
		
		$result = Array(
			"html" => $html->getHTML(),
			"step" => "settings",
			"button" => "next",
			"error" => ""
		);
		die (json_encode($result));
	}
	
	
	/*
		SAVE THE SETTINGS
		SHOW FINAL SCREEN
	*/
	if ($_POST['step'] == "settings") {
		require $config['sqlfile'];
		$sql = new MySQL();
		$secure = new Security();
		
		
		// Save the settings from the form
		if (isset($_POST['input'])) {
			foreach ($_POST['input'] as $name => $value) {
				$sql->query('UPDATE '.$sql->prefix.'settings SET value = "'.$value.'" WHERE name = "'.$name.'"');
			}
		}
		
		
		// Show the last screen
		$sql->query('SELECT name FROM '.$sql->prefix.'users WHERE id = "1"');
		$result = $sql->fetchRow(); $adminname = $result['name'];
		
		eval ("\$html = \"".get_template("done")."\";");
		$html = new PQLite($html);
		
		
		$result = Array(
			"html" => $html->getHTML(),
			"step" => "settings",
			"button" => "Log into the adminpanel",
			"error" => "",
			"href" => "../admin/"
		);
		die (json_encode($result));
	}
?>